ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.20 by root, Mon Dec 13 17:35:51 2010 UTC vs.
Revision 1.33 by root, Thu Feb 24 07:10:03 2011 UTC

6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10# perl build variables 10# perl build variables
11MAKE=make
11PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
12PERL_CC=cc 13PERL_CC=cc
13PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
14PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
15PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
16 17
17ARCH="$(uname -m)" 18ARCH="$(uname -m)"
18 19
19case "$ARCH" in 20case "$ARCH" in
20 i*86 | x86_64 | amd64 ) 21 i*86 | x86_64 | amd64 )
21 #PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 22 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
22 PERL_OPTIMIZE="$PERL_OPTIMIZE" # x86/amd64
23 case "$ARCH" in 23 case "$ARCH" in
24 i*86 ) 24 i*86 )
25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
26 ;; 26 ;;
27 esac 27 esac
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 36
37# some configuration options for modules 37# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
41 42
42# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
43# required by mkbundle 44# required by mkbundle
44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
45 46
66 67
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}" 68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69 70
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
71export LC_ALL=C # just to be on the safe side 72LC_ALL=C; export LC_ALL # just to be on the safe side
72 73
73# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
74VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
75$VERSION=0.911 76$VERSION="1.1"
76 77
77BZ2=bz2 78BZ2=bz2
78BZIP2=bzip2 79BZIP2=bzip2
79 80
80fatal() { 81fatal() {
126 127
127clean() { 128clean() {
128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
129} 130}
130 131
132realclean() {
133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
136}
137
131fetch() { 138fetch() {
132 rcd "$STATICPERL" 139 rcd "$STATICPERL"
133 140
134 mkdir -p src 141 mkdir -p src
135 rcd src 142 rcd src
145perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
146trying $URL 153trying $URL
147EOF 154EOF
148 155
149 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
150 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
151 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
152 || fatal "$URL: unable to download" 159 || fatal "$URL: unable to download"
153 rm -f perl-$PERL_VERSION.tar.$BZ2 160 rm -f perl-$PERL_VERSION.tar.$BZ2
154 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
155 fi 162 fi
156 163
158unpacking perl 165unpacking perl
159EOF 166EOF
160 167
161 mkdir -p unpack 168 mkdir -p unpack
162 rm -rf unpack/perl-$PERL_VERSION 169 rm -rf unpack/perl-$PERL_VERSION
163 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | tar xfC - unpack \
164 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
165 chmod -R u+w unpack/perl-$PERL_VERSION 172 chmod -R u+w unpack/perl-$PERL_VERSION
166 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
167 rmdir -p unpack 174 rmdir -p unpack
168 fi 175 fi
169} 176}
173 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
174 rm -f "$2" 181 rm -f "$2"
175 mv "$2~" "$2" 182 mv "$2~" "$2"
176} 183}
177 184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
209}
210
178configure() { 211configure() {
179 fetch 212 fetch
180 213
181 rcd "$STATICPERL/src/perl-$PERL_VERSION" 214 rcd "$STATICPERL/src/perl-$PERL_VERSION"
182 215
186configuring $STATICPERL/src/perl-$PERL_VERSION 219configuring $STATICPERL/src/perl-$PERL_VERSION
187EOF 220EOF
188 221
189 rm -f "$PERL_PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
190 223
191 make distclean >/dev/null 2>&1 224 "$MAKE" distclean >/dev/null 2>&1
192 225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
193 # I hate them 228 # I hate them for this
194 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
195 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
196 231
197 preconfigure 232 preconfigure
198 233
204 -Uusethreads \ 239 -Uusethreads \
205 -Uuseithreads \ 240 -Uuseithreads \
206 -Uusemultiplicity \ 241 -Uusemultiplicity \
207 -Uusesfio \ 242 -Uusesfio \
208 -Uuseshrplib \ 243 -Uuseshrplib \
244 -Uinstallusrbinperl \
245 -A ccflags=" $PERL_CCFLAGS" \
209 -Dcc="$PERL_CC" \ 246 -Dcc="$PERL_CC" \
210 -Dcppflags="$PERL_CPPFLAGS" \
211 -Dccflags="-g2 -fno-strict-aliasing" \
212 -Doptimize="$PERL_OPTIMIZE" \ 247 -Doptimize="$PERL_OPTIMIZE" \
213 -Dldflags="$PERL_LDFLAGS" \ 248 -Dldflags="$PERL_LDFLAGS" \
214 -Dlibs="$PERL_LIBS" \ 249 -Dlibs="$PERL_LIBS" \
215 -Dprefix="$PERL_PREFIX" \ 250 -Dprefix="$PERL_PREFIX" \
216 -Dbin="$PERL_PREFIX/bin" \ 251 -Dbin="$PERL_PREFIX/bin" \
217 -Dprivlib="$PERL_PREFIX/lib" \ 252 -Dprivlib="$PERL_PREFIX/lib" \
218 -Darchlib="$PERL_PREFIX/lib" \ 253 -Darchlib="$PERL_PREFIX/lib" \
219 -Uusevendorprefix \ 254 -Uusevendorprefix \
220 -Dsitelib="$PERL_PREFIX/lib" \ 255 -Dsitelib="$PERL_PREFIX/lib" \
221 -Dsitearch="$PERL_PREFIX/lib" \ 256 -Dsitearch="$PERL_PREFIX/lib" \
222 -Usitelibexp \
223 -Uman1dir \ 257 -Uman1dir \
224 -Uman3dir \ 258 -Uman3dir \
225 -Usiteman1dir \ 259 -Usiteman1dir \
226 -Usiteman3dir \ 260 -Usiteman3dir \
227 -Dpager=/usr/bin/less \ 261 -Dpager=/usr/bin/less \
228 -Demail="$EMAIL" \ 262 -Demail="$EMAIL" \
229 -Dcf_email="$EMAIL" \ 263 -Dcf_email="$EMAIL" \
230 -Dcf_by="$EMAIL" \ 264 -Dcf_by="$EMAIL" \
231 $PERL_CONFIGURE \ 265 $PERL_CONFIGURE \
232 -Duseperlio \ 266 -Duseperlio \
233 -dE || fatal "Configure failed" 267 -dE || configure_failure
234 268
235 sedreplace ' 269 sedreplace '
236 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 270 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
237 s/ *-fno-stack-protector */ /g 271 s/ *-fno-stack-protector */ /g
238 ' config.sh 272 ' config.sh
253building $STATICPERL/src/perl-$PERL_VERSION 287building $STATICPERL/src/perl-$PERL_VERSION
254EOF 288EOF
255 289
256 rm -f "$PERL_PREFIX/staticstamp.install" 290 rm -f "$PERL_PREFIX/staticstamp.install"
257 291
258 make || fatal "make: error while building perl" 292 "$MAKE" || fatal "make: error while building perl"
259 293
260 postbuild || fatal "postbuild hook failed" 294 postbuild || fatal "postbuild hook failed"
261} 295}
262 296
263install() { 297install() {
273 ln -sf "perl/lib/" "$STATICPERL/lib" 307 ln -sf "perl/lib/" "$STATICPERL/lib"
274 308
275 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 309 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
276 rm -rf "$PERL_PREFIX" # by this rm -rf 310 rm -rf "$PERL_PREFIX" # by this rm -rf
277 311
278 make install || fatal "make install: error while installing" 312 "$MAKE" install || fatal "make install: error while installing"
279 313
280 rcd "$PERL_PREFIX" 314 rcd "$PERL_PREFIX"
281 315
282 # create a "make install" replacement for CPAN 316 # create a "make install" replacement for CPAN
283 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 317 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
284make || exit 318"$MAKE" || exit
285 319
286if find blib/arch/auto -type f | grep -q -v .exists; then 320if find blib/arch/auto -type f | grep -q -v .exists; then
287 echo Probably an XS module, rebuilding perl 321 echo Probably an XS module, rebuilding perl
288 if make perl; then 322 if "$MAKE" perl; then
289 mv perl "$PERL_PREFIX"/bin/perl~ \ 323 mv perl "$PERL_PREFIX"/bin/perl~ \
290 && rm -f "$PERL_PREFIX"/bin/perl \ 324 && rm -f "$PERL_PREFIX"/bin/perl \
291 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl 325 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
292 make -f Makefile.aperl map_clean 326 "$MAKE" -f Makefile.aperl map_clean
293 else 327 else
294 make -f Makefile.aperl map_clean 328 "$MAKE" -f Makefile.aperl map_clean
295 exit 1 329 exit 1
296 fi 330 fi
297fi 331fi
298 332
299make install UNINST=1 333"$MAKE" install UNINST=1
300EOF 334EOF
301 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 335 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
302 336
303 # trick CPAN into avoiding ~/.cpan completely 337 # trick CPAN into avoiding ~/.cpan completely
304 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 338 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
364 for mod in "$@"; do 398 for mod in "$@"; do
365 echo 399 echo
366 echo $mod 400 echo $mod
367 ( 401 (
368 rcd $mod 402 rcd $mod
369 make -f Makefile.aperl map_clean >/dev/null 2>&1 403 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
370 make distclean >/dev/null 2>&1 404 "$MAKE" distclean >/dev/null 2>&1
371 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 405 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
372 make || fatal "$mod: error building module" 406 "$MAKE" || fatal "$mod: error building module"
373 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 407 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
374 make distclean >/dev/null 2>&1 408 "$MAKE" distclean >/dev/null 2>&1
375 exit 0 409 exit 0
376 ) || exit $? 410 ) || exit $?
377 done 411 done
378} 412}
379 413
427 command="${1#--}"; shift 461 command="${1#--}"; shift
428 case "$command" in 462 case "$command" in
429 version ) 463 version )
430 echo "staticperl version $VERSION" 464 echo "staticperl version $VERSION"
431 ;; 465 ;;
432 fetch | configure | build | install | clean | distclean) 466 fetch | configure | build | install | clean | realclean | distclean)
433 ( "$command" ) 467 ( "$command" ) || exit
434 ;; 468 ;;
435 instsrc ) 469 instsrc )
436 ( instsrc "$@" ) 470 ( instsrc "$@" ) || exit
437 exit 471 exit
438 ;; 472 ;;
439 instcpan ) 473 instcpan )
440 ( instcpan "$@" ) 474 ( instcpan "$@" ) || exit
441 exit 475 exit
442 ;; 476 ;;
443 cpan ) 477 cpan )
444 ( install ) 478 ( install ) || exit
445 "$PERL_PREFIX/bin/cpan" "$@" 479 "$PERL_PREFIX/bin/cpan" "$@"
446 exit 480 exit
447 ;; 481 ;;
448 mkbundle ) 482 mkbundle )
449 ( install ) 483 ( install ) || exit
450 bundle "$@" 484 bundle "$@"
451 exit 485 exit
452 ;; 486 ;;
453 mkperl ) 487 mkperl )
454 ( install ) 488 ( install ) || exit
455 bundle --perl "$@" 489 bundle --perl "$@"
456 exit 490 exit
457 ;; 491 ;;
458 mkapp ) 492 mkapp )
459 ( install ) 493 ( install ) || exit
460 bundle --app "$@" 494 bundle --app "$@"
461 exit 495 exit
462 ;; 496 ;;
463 help ) 497 help )
464 podusage 2 498 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines